<template lang="pug">
.box.mx-auto
	form.form( @submit.prevent='submit' )
		b-field( label="Имя пользователя" on-border )
			b-input( v-model='username' )
		b-field( label="Пароль" on-border )
			b-input( v-model='password' input-type="password" )
		b-field
			button.button.is-link.is-fullwidth( :class='{ "is-loading": pending }' ) Войти
</template>

<script setup>
import BField from "@/components/form/Field.vue"
import BInput from "@/components/form/Input.vue"

import { ref, computed, onMounted } from "vue"
import { useUserStore } from "@/stores/user"
import { useRouter } from "vue-router"

const $router = useRouter()
const us = useUserStore()

const username = ref(null)
const password = ref(null)
const pending = ref(false)

const body = computed(() => ({
	username: username.value,
	password: password. value
}))

const submit = async () => {
	pending.value = true
	try {
		await us.authByCredentials(body.value)
		$router.push({ name: "Chats" })
		pending.value = false
	} catch(err) {
		pending.value = false
	}
}

onMounted(() => {
	if (us.isAuthorized)
		$router.push({ name: "Chats" })
})
</script>

<style lang="scss" scoped>
.box {
	max-width: 320px;
}
</style>